



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MQTT研究之mosquitto：【环境搭建】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MQTT研究之mosquitto：【环境搭建】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 17:22:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>环境信息：</strong></p>
<p>1. Linux Centos7.2 环境，CPU 2核，内存8G.</p>
<p>2. mosquitto版本：mosquitto-1.5.4</p>
<p>官网：<a href="http://mosquitto.org/download/" rel="external nofollow noreferrer">http://mosquitto.org/download/</a><br />libwebsockets官网： <a href="https://libwebsockets.org/" rel="external nofollow noreferrer">https://libwebsockets.org/</a></p>
<p>本环境搭建，主要用到了mosquitto，么有涉及websocket的内容，所以，这里不做安装介绍。</p>
<p><strong>搭建过程：</strong></p>
<p>1. 安装mosquitto-1.5.4</p>
<p>下载解压缩mosquitto-1.5.4.tar.gz。然后执行make</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto-1.5.]# make<br />
set -e; for d in lib client src; do make -C ${d}; done<br />
make[]: Entering directory `/opt/mosquitto-1.5./lib'<br />
cc -Wall -ggdb -O2  -I. -I.. -I../lib -fPIC -DWITH_TLS -DWITH_TLS_PSK -DWITH_THREADING -DWITH_SOCKS -c mosquitto.c -o mosquitto.o<br />
In file included from mosquitto.c:::<br />
mosquitto_internal.h::: fatal error: openssl/ssl.h: No such file or directory<br />
 #  include &lt;openssl/ssl.h&gt;<br />
                           ^<br />
compilation terminated.<br />
make[]: *** [mosquitto.o] Error<br />
make[]: Leaving directory `/opt/mosquitto-1.5./lib'<br />
make: *** [mosquitto] Error </pre>
</div>
<p><strong>上述错误是因为没有安装openssl-devel</strong>。安装上openssl-devel即可解决： yum install openssl-devel</p>
<div>
<pre class="prettyprint linenums">make -C cpp<br />
make[]: Entering directory `/opt/mosquitto-1.5./lib/cpp'<br />
g++ -Wall -ggdb -O2  -I. -I.. -I../lib -fPIC -c mosquittopp.cpp -o mosquittopp.o<br />
make[]: g++: Command not found<br />
make[]: *** [mosquittopp.o] Error<br />
make[]: Leaving directory `/opt/mosquitto-1.5./lib/cpp'<br />
make[]: *** [all] Error<br />
make[]: Leaving directory `/opt/mosquitto-1.5./lib'</pre>
</div>
<p><strong>上述错误是因为没有安装gcc-c++</strong>. 安装上gcc-c++即可解决： yum install gcc-c++</p>
<div>
<pre class="prettyprint linenums">cc -I.. -Wall -ggdb -O2  -c mosquitto_passwd.c -o mosquitto_passwd.o<br />
cc mosquitto_passwd.o -o mosquitto_passwd  -lcrypto<br />
make[]: Leaving directory `/opt/mosquitto-1.5./src'<br />
set -e; for d in man; do make -C ${d}; done<br />
make[]: Entering directory `/opt/mosquitto-1.5./man'<br />
make[]: Nothing to be done for `all'.<br />
make[]: Leaving directory `/opt/mosquitto-1.5./man'</pre>
</div>
<p><strong>上述错误是因为没有安装c-ares-devel</strong>. 安装上c-ares-devel即可解决： yum install c-ares-devel</p>
<p>解决上面的问题，可以一次安装下面的所有的依赖：yum -y install gcc gcc-c++ openssl-devel c-ares-devel libuuid-devel wget cmake</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto-1.5.]# yum -y install gcc gcc-c++ openssl-devel c-ares-devel libuuid-devel wget cmake<br />
Loaded plugins: fastestmirror<br />
Loading mirror speeds from cached hostfile<br />
Package gcc-4.8.-.el7.x86_64 already installed and latest version<br />
Package gcc-c++-4.8.-.el7.x86_64 already installed and latest version<br />
Package :openssl-devel-1.0.2k-.el7.x86_64 already installed and latest version<br />
Package c-ares-devel-1.10.-.el7.x86_64 already installed and latest version<br />
Package libuuid-devel-2.23.-.el7.x86_64 already installed and latest version<br />
Package wget-1.14-.el7_4..x86_64 already installed and latest version<br />
Package cmake-2.8.12.2-.el7.x86_64 already installed and latest version</pre>
</div>
<p>2. 配置mosquitto</p>
<p>进入/etc/mosquitto目录</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# cp mosquitto.conf.example mosquitto.conf<br />
[root@ws2 mosquitto]# cp pwfile.example pwfile</pre>
</div>
<p>vi mosquitto.conf，做下面配置</p>
<div>
<pre class="prettyprint linenums">allow_anonymous true<br />
password_file /etc/mosquitto/pwfile</pre>
</div>
<p>然后，在文件最末尾补充（mosquitto服务监听的端口）：</p>
<div>
<pre class="prettyprint linenums">port 1883

listener 9090

protocol websockets</pre>
</div>
<p>3. 启动mosquitto</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# mosquitto -c /etc/mosquitto/mosquitto.conf<br />
Error: Websockets support not available.<br />
Error found at /etc/mosquitto/mosquitto.conf:.<br />
Error: Unable to open configuration file.</pre>
</div>
<p>这个错误，是因为我没有安装websockets模块，另外，config.mk里面的websocket没有配置为YES。所以将配置中websocket的注释掉即可。</p>
<div>
<pre class="prettyprint linenums">#listener<br />
#protocol websockets</pre>
</div>
<p>再次启动：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# mosquitto -c /etc/mosquitto/mosquitto.conf<br />
: mosquitto version 1.5. starting<br />
: Config loaded from /etc/mosquitto/mosquitto.conf.<br />
: Opening ipv4 listen socket on port .<br />
: Opening ipv6 listen socket on port .<br />
: Error: Invalid user 'mosquitto'.</pre>
</div>
<p><strong>上述错误显示没有mosquitto用户，创建用户并添加组</strong>。</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# groupadd mosquitto<br />
[root@ws2 mosquitto]# useradd -g mosquitto mosquitto</pre>
</div>
<p>最后再次启动：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# mosquitto -c /etc/mosquitto/mosquitto.conf<br />
: mosquitto version 1.5. starting<br />
: Config loaded from /etc/mosquitto/mosquitto.conf.<br />
: Opening ipv4 listen socket on port .<br />
: Opening ipv6 listen socket on port .</pre>
</div>
<p>此时，<strong>mosquitto以前台服务的方式在运行</strong>。。。如何使用，请看帮助信息：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# mosquitto --help<br />
mosquitto version 1.5.

mosquitto is an MQTT v3.1.1 broker.

Usage: mosquitto [-c config_file] [-d] [-h] [-p port]

 -c : specify the broker config file.<br />
 -d : put the broker into the background after starting.<br />
 -h : display this help.<br />
 -p : start the broker listening on the specified port.<br />
      Not recommended in conjunction with the -c option.<br />
 -v : verbose mode - enable all logging types. This overrides<br />
      any logging options given in the config file.

See http://mosquitto.org/ for more information.</pre>
</div>
<p>4. 测试验证</p>
<div>
<pre class="prettyprint linenums">[root@ws2 ~]# mosquitto_sub -t rulee<br />
mosquitto_sub: error while loading shared libraries: libmosquitto.so.: cannot open shared object file: No such file or directory</pre>
</div>
<p>此处错误，表明动态库没有配合好路径，参照下面的操作（<strong>主要是红色的两行指令</strong>）：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 ~]# cat /etc/ld.so.conf<br />
include ld.so.conf.d/*.conf<br />
[root@ws2 ~]#<br />
[root@ws2 ~]# <strong>echo "/usr/local/lib" &gt;&gt; /etc/ld.so.conf</strong><br />
[root@ws2 ~]#<br />
[root@ws2 ~]# vi /etc/ld.so.conf<br />
include ld.so.conf.d/*.conf<br />
/usr/local/lib<br />
[root@ws2 ~]# <strong>ldconfig</strong></pre>
</div>
<p>然后再次订阅一个rulee的topic：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/844237/201812/844237-20181210131330882-798964719.jpg" /></p>
<p>然后，再启动一个终端，进行发布消息操作：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 ~]# mosquitto_pub -h localhost -t rulee -m "hello rule engine"</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/844237/201812/844237-20181210131402714-695424594.jpg" /></p>
<p>在上面的订阅窗口已经收到这个发布的消息</p>
<div>
<pre class="prettyprint linenums">[root@ws2 ~]# mosquitto_sub -t rulee<br />
hello rule engine</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/844237/201812/844237-20181210131435986-2086256095.jpg" /></p>
<p><strong>安全控制：</strong></p>
<p>上面的操作，是针对无安全控制的，下面，进行带安全控制的配置，进入/etc/mosquitto目录：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# cp mosquitto.conf.example mosquitto.conf<br />
[root@ws2 mosquitto]# cp pwfile.example pwfile<br />
[root@ws2 mosquitto]# cp aclfile.example aclfile</pre>
</div>
<p>vi mosquitto.conf，做下面配置</p>
<div>
<pre class="prettyprint linenums">allow_anonymous false<br />
password_file /etc/mosquitto/pwfile<br />
acl_file /etc/mosquitto/aclfile</pre>
</div>
<p>然后，在文件最末尾补充监听端口（若没有配置的话）：&nbsp;port 1883</p>
<p>添加安全用户信息：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# mosquitto_passwd -c /etc/mosquitto/pwfile shihuc<br />
Password:<br />
Reenter password: </pre>
</div>
<p>重新启动mosquitto服务：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 mosquitto]# mosquitto -d -c /etc/mosquitto/mosquitto.conf</pre>
</div>
<p>订阅：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 ~]# mosquitto_sub -t rulee<br />
hello rule engine<br />
Connection Refused: not authorised.<br />
[root@ws2 ~]#<br />
[root@ws2 ~]#<br />
[root@ws2 ~]# mosquitto_sub -t /taikang/rulee -u shihuc -P shihuc</pre>
</div>
<p>发布：</p>
<div>
<pre class="prettyprint linenums">[root@ws2 ~]# mosquitto_pub -h localhost -t /taikang/rulee -m "hello rule engine with auth"<br />
Connection Refused: not authorised.<br />
Error: The connection was refused.<br />
[root@ws2 ~]#<br />
[root@ws2 ~]#<br />
[root@ws2 ~]# mosquitto_pub -u shihuc -P shihuc -h localhost -t /taikang/rulee -m "hello rule engine with auth"<br />
[root@ws2 ~]# </pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qngdvj8.html">关于swfupload，客户端中文乱码解决方案&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvo6pz8.html">【python】Head First Python（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1epl29.html">iPhone取消软件更新上边的1</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5w718.html">js转换 &sol;Date&lpar;1464671903000&rpar;&sol; 格式的日期的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vn3om8.html">Andstudio更新失败的解决办法。</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xlz4v8.html">HTML5的你应该记住的一些知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn3el6q.html">（原）caffe中通过图像生成lmdb格式的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdppjd7q.html">基于Cocos2dx开发卡牌游戏&lowbar;松开，这三个国家</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kj4659.html">算法模板&mdash;&mdash;线段树6（二维线段树：区域加法&plus;区域求和）（求助phile）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk6knv8.html">mysql用户权限管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mermwrq.html">用html&plus;css&plus;js做打地鼠小游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyrvnz9.html">无法将类型为&OpenCurlyDoubleQuote;System&period;DBNull&rdquo;的对象强制转换为类型&OpenCurlyDoubleQuote;System&period;String&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4p2l8.html">Myeclipse Db Browser使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g764eq.html">Python基础教程&lpar;第3版&rpar;   笔记（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2356pq.html">ubuntu下安装nginx1&period;11&period;10</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kjkpvq.html">vue首屏加载优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pjwe08.html">GSAP JS基础教程--认识GSAP JS</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4y36xq.html">UWP开发入门（九）&mdash;&mdash;简单界面的布局技巧及屏幕适应</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwleloz9.html">IIS 之 线程池最大线程数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7erpee9.html">thinkphp3&period;2&plus;cropper上传多张图片剪切图片</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zy6yox9.html">React文档（十）表单</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25gkm3q.html">The C compiler identification is unknown解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjkog39.html">QSplineSeries QChartView绘制曲线</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o13vz5q.html">PHP写的验证码类</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gzj0vq.html">&lbrack;Linux&rsqb;Redhat7配置CentOS7 YUM源</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w3vz0q.html">奇异值分解（SVD）与在降维中的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwgg6x9.html">iOS 弹幕制作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllwpkeq.html">Day 2&colon; ASP&period;NET and python trying</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25g6mwq.html">linux下GCC编译文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvnz2y8.html">Gym - 100783G：Playing With Geometry （几何 离散化 ）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
